

#include "built_in.h"
#include "Convertions.h"
 // LCD module connections
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
// End LCD module connections
unsigned int adc_rd = 0;
float voltage;
char txt[6];

void Set_up() {

  ANSEL = 0x04;      // Pin RA2 sets as analog input.
  TRISA = 0x04;
  ADCON1 = 0x82;    // the Vref is Vcc.
  ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  ADC_Init();
  delay_us(100);
  Lcd_Init();
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Cmd(_LCD_CURSOR_OFF);
  Delay_ms(10);
}

void main() {
   Set_up();
   Lcd_Out(1, 5, "Voltage");
   LOOP:
   adc_rd = ADC_Get_Sample(2);
   delay_ms(10);
   voltage=adc_rd*0.004887;/* 5/1023 */
   Float_to_Str(voltage, txt, 3);
   Lcd_Out(2,6, txt);
   delay_ms(500);
   goto LOOP;
}
